scala.reflect.macros

# Enclosures

###
Related Doc: package macros

#### trait Enclosures extends AnyRef

EXPERIMENTAL

A slice of the Scala macros context that exposes enclosing trees (method, class, compilation unit and currently compiled macro application), the enclosing position of the macro expansion, as well as macros and implicits that are currently in-flight.

Starting from Scala 2.11.0, the APIs to get the trees enclosing by the current macro application are deprecated, and the reasons for that are two-fold. Firstly, we would like to move towards the philosophy of locally-expanded macros, as it has proven to be important for understanding of code. Secondly, within the current architecture of scalac, we are unable to have c.enclosingTree-style APIs working robustly. Required changes to the typechecker would greatly exceed the effort that we would like to expend on this feature given the existence of more pressing concerns at the moment. This is somewhat aligned with the overall evolution of macros during the 2.11 development cycle, where we played with `c.introduceTopLevel` and `c.introduceMember`, but at the end of the day decided to reject them.

If you're relying on the now deprecated APIs, consider using the new c.internal.enclosingOwner method that can be used to obtain the names of enclosing definitions. Alternatively try reformulating your macros in terms of completely local expansion and/or joining a discussion of a somewhat related potential language feature at https://groups.google.com/forum/#!topic/scala-debate/f4CLmYShX6Q. We also welcome questions and suggestions on our mailing lists, where we would be happy to further discuss this matter.

Self Type
  blackbox.Context
Source
  Enclosures.scala

Linear Supertypes
AnyRef, Any
Known Subclasses
Context, Context
Type Hierarchy Learn more about scaladoc diagrams
Ordering

1. Alphabetic
2. By inheritance

Inherited

1. Enclosures
2. AnyRef
3. Any

Implicitly

1. by any2stringadd
2. by StringFormat
3. by Ensuring
4. by ArrowAssoc

1. Hide All
2. Show all

Learn more about member selection
Visibility

1. Public
2. All

### Type Members

1. #### case class EnclosureException(expected: Class[_], enclosingTrees: List[blackbox.Context.Tree]) extends Exception with Product with Serializable

   Indicates than one of the enclosure methods failed to find a tree of required type among enclosing trees.

   Indicates than one of the enclosure methods failed to find a tree of required type among enclosing trees.

   Annotations
     @deprecated
   Deprecated

     (Since version 2.11.0) c.enclosingTree-style APIs are now deprecated; consult the scaladoc for more information

   See also

     scala.reflect.macros.Enclosures

### Abstract Value Members

1. #### abstract def enclosingMacros: List[blackbox.Context]

   Contexts that represent macros in-flight, including the current one.

   Contexts that represent macros in-flight, including the current one. Very much like a stack trace, but for macros only. Can be useful for interoperating with other macros and for imposing compiler-friendly limits on macro expansion.

   Is also priceless for emitting sane error messages for macros that are called by other macros on synthetic (i.e. position-less) trees. In that dire case navigate the `enclosingMacros` stack, and it will most likely contain at least one macro with a position-ful macro application. See `enclosingPosition` for a default implementation of this logic.

   Unlike `openMacros`, this is a val, which means that it gets initialized when the context is created and always stays the same regardless of whatever happens during macro expansion.

2. #### abstract def enclosingPosition: blackbox.Context.Position

   Tries to guess a position for the enclosing application.

   Tries to guess a position for the enclosing application. But that is simple, right? Just dereference `pos` of `macroApplication`? Not really. If we're in a synthetic macro expansion (no positions), we must do our best to infer the position of something that triggered this expansion. Surprisingly, quite often we can do this by navigation the `enclosingMacros` stack.

3. #### abstract def macroApplication: blackbox.Context.Tree

   The tree that undergoes macro expansion.

   The tree that undergoes macro expansion. Can be useful to get an offset or a range position of the entire tree being processed.

4. #### abstract def enclosingClass: blackbox.Context.Tree

   Tree that corresponds to the enclosing class, or EmptyTree if not applicable.

   Tree that corresponds to the enclosing class, or EmptyTree if not applicable.

   Annotations
     @deprecated
   Deprecated

     (Since version 2.11.0) c.enclosingTree-style APIs are now deprecated; consult the scaladoc for more information

   See also

     scala.reflect.macros.Enclosures

5. #### abstract def enclosingDef: Universe.DefDef

   Tree that corresponds to the enclosing DefDef tree.

   Tree that corresponds to the enclosing DefDef tree. Throws `EnclosureException` if there's no such enclosing tree.

   Annotations
     @deprecated
   Deprecated

     (Since version 2.11.0) c.enclosingTree-style APIs are now deprecated; consult the scaladoc for more information

   See also

     scala.reflect.macros.Enclosures

6. #### abstract def enclosingImpl: Universe.ImplDef

   Tree that corresponds to the enclosing ImplDef tree (i.e.

   Tree that corresponds to the enclosing ImplDef tree (i.e. either ClassDef or ModuleDef). Throws `EnclosureException` if there's no such enclosing tree.

   Annotations
     @deprecated
   Deprecated

     (Since version 2.11.0) c.enclosingTree-style APIs are now deprecated; consult the scaladoc for more information

   See also

     scala.reflect.macros.Enclosures

7. #### abstract def enclosingMethod: blackbox.Context.Tree

   Tree that corresponds to the enclosing method, or EmptyTree if not applicable.

   Tree that corresponds to the enclosing method, or EmptyTree if not applicable.

   Annotations
     @deprecated
   Deprecated

     (Since version 2.11.0) c.enclosingTree-style APIs are now deprecated; consult the scaladoc for more information

   See also

     scala.reflect.macros.Enclosures

8. #### abstract def enclosingPackage: Universe.PackageDef

   Tree that corresponds to the enclosing PackageDef tree.

   Tree that corresponds to the enclosing PackageDef tree. Throws `EnclosureException` if there's no such enclosing tree.

   Annotations
     @deprecated
   Deprecated

     (Since version 2.11.0) c.enclosingTree-style APIs are now deprecated; consult the scaladoc for more information

   See also

     scala.reflect.macros.Enclosures

9. #### abstract def enclosingRun: blackbox.Context.Run

   Compilation run that contains this macro application.

   Compilation run that contains this macro application.

   Annotations
     @deprecated
   Deprecated

     (Since version 2.11.0) c.enclosingTree-style APIs are now deprecated; consult the scaladoc for more information

   See also

     scala.reflect.macros.Enclosures

10. #### abstract def enclosingTemplate: Universe.Template

    Tree that corresponds to the enclosing Template tree.

    Tree that corresponds to the enclosing Template tree. Throws `EnclosureException` if there's no such enclosing tree.

    Annotations
      @deprecated
    Deprecated

      (Since version 2.11.0) c.enclosingTree-style APIs are now deprecated; consult the scaladoc for more information

    See also

      scala.reflect.macros.Enclosures

11. #### abstract def enclosingUnit: blackbox.Context.CompilationUnit

    Compilation unit that contains this macro application.

    Compilation unit that contains this macro application.

    Annotations
      @deprecated
    Deprecated

      (Since version 2.11.0) c.enclosingTree-style APIs are now deprecated; consult the scaladoc for more information

    See also

      scala.reflect.macros.Enclosures

### Concrete Value Members

1. #### final def !=(arg0: Any): Boolean

   Test two objects for inequality.

   Test two objects for inequality.

   returns

     `true` if !(this == that), false otherwise.

   Definition Classes
     AnyRef → Any

2. #### final def ##(): Int

   Equivalent to `x.hashCode` except for boxed numeric types and `null`.

   Equivalent to `x.hashCode` except for boxed numeric types and `null`. For numerics, it returns a hash value which is consistent with value equality: if two value type instances compare as true, then ## will produce the same hash value for each of them. For `null` returns a hashcode where `null.hashCode` throws a `NullPointerException`.

   returns

     a hash value consistent with ==

   Definition Classes
     AnyRef → Any

3. #### def +(other: String): String

   Implicit information
     This member is added by an implicit conversion from Enclosures to any2stringadd[Enclosures] performed by method any2stringadd in scala.Predef.
   Definition Classes
     any2stringadd

4. #### def ->[B](y: B): (Enclosures, B)

   Implicit information
     This member is added by an implicit conversion from Enclosures to ArrowAssoc[Enclosures] performed by method ArrowAssoc in scala.Predef.
   Definition Classes
     ArrowAssoc
   Annotations
     @inline()

5. #### final def ==(arg0: Any): Boolean

   The expression `x == that` is equivalent to `if (x eq null) that eq null else x.equals(that)`.

   The expression `x == that` is equivalent to `if (x eq null) that eq null else x.equals(that)`.

   arg0

     the object to compare against this object for equality.

   returns

     `true` if the receiver object is equivalent to the argument; `false` otherwise.

   Definition Classes
     AnyRef → Any

6. #### final def asInstanceOf[T0]: T0

   Cast the receiver object to be of type `T0`.

   Cast the receiver object to be of type `T0`.

   Note that the success of a cast at runtime is modulo Scala's erasure semantics. Therefore the expression `1.asInstanceOf[String]` will throw a `ClassCastException` at runtime, while the expression `List(1).asInstanceOf[List[String]]` will not. In the latter example, because the type argument is erased as part of compilation it is not possible to check whether the contents of the list are of the requested type.

   returns

     the receiver object.

   Definition Classes
     Any
   Exceptions thrown

     `ClassCastException` if the receiver object is not an instance of the erasure of type `T0`.

7. #### def clone(): AnyRef

   Create a copy of the receiver object.

   Create a copy of the receiver object.

   The default implementation of the `clone` method is platform dependent.

   returns

     a copy of the receiver object.

   Attributes
     protected[java.lang]
   Definition Classes
     AnyRef
   Annotations
     @throws( ... )
   Note

     not specified by SLS as a member of AnyRef

8. #### def ensuring(cond: (Enclosures) ⇒ Boolean, msg: ⇒ Any): Enclosures

   Implicit information
     This member is added by an implicit conversion from Enclosures to Ensuring[Enclosures] performed by method Ensuring in scala.Predef.
   Definition Classes
     Ensuring

9. #### def ensuring(cond: (Enclosures) ⇒ Boolean): Enclosures

   Implicit information
     This member is added by an implicit conversion from Enclosures to Ensuring[Enclosures] performed by method Ensuring in scala.Predef.
   Definition Classes
     Ensuring

10. #### def ensuring(cond: Boolean, msg: ⇒ Any): Enclosures

    Implicit information
      This member is added by an implicit conversion from Enclosures to Ensuring[Enclosures] performed by method Ensuring in scala.Predef.
    Definition Classes
      Ensuring

11. #### def ensuring(cond: Boolean): Enclosures

    Implicit information
      This member is added by an implicit conversion from Enclosures to Ensuring[Enclosures] performed by method Ensuring in scala.Predef.
    Definition Classes
      Ensuring

12. #### final def eq(arg0: AnyRef): Boolean

    Tests whether the argument (`arg0`) is a reference to the receiver object (`this`).

    Tests whether the argument (`arg0`) is a reference to the receiver object (`this`).

    The `eq` method implements an equivalence relation on non-null instances of `AnyRef`, and has three additional properties:

    - It is consistent: for any non-null instances `x` and `y` of type `AnyRef`, multiple invocations of `x.eq(y)` consistently returns `true` or consistently returns `false`.
    - For any non-null instance `x` of type `AnyRef`, `x.eq(null)` and `null.eq(x)` returns `false`.
    - `null.eq(null)` returns `true`.

    When overriding the `equals` or `hashCode` methods, it is important to ensure that their behavior is consistent with reference equality. Therefore, if two objects are references to each other (`o1 eq o2`), they should be equal to each other (`o1 == o2`) and they should hash to the same value (`o1.hashCode == o2.hashCode`).

    returns

      `true` if the argument is a reference to the receiver object; `false` otherwise.

    Definition Classes
      AnyRef

13. #### def equals(arg0: Any): Boolean

    The equality method for reference types.

    The equality method for reference types. Default implementation delegates to `eq`.

    See also `equals` in scala.Any.

    returns

      `true` if the receiver object is equivalent to the argument; `false` otherwise.

    Definition Classes
      AnyRef → Any

14. #### def finalize(): Unit

    Called by the garbage collector on the receiver object when there are no more references to the object.

    Called by the garbage collector on the receiver object when there are no more references to the object.

    The details of when and if the `finalize` method is invoked, as well as the interaction between `finalize` and non-local returns and exceptions, are all platform dependent.

    Attributes
      protected[java.lang]
    Definition Classes
      AnyRef
    Annotations
      @throws( classOf[java.lang.Throwable] )
    Note

      not specified by SLS as a member of AnyRef

15. #### def formatted(fmtstr: String): String

    Implicit information
      This member is added by an implicit conversion from Enclosures to StringFormat[Enclosures] performed by method StringFormat in scala.Predef.
    Definition Classes
      StringFormat
    Annotations
      @inline()

16. #### final def getClass(): Class[_]

    A representation that corresponds to the dynamic class of the receiver object.

    A representation that corresponds to the dynamic class of the receiver object.

    The nature of the representation is platform dependent.

    returns

      a representation that corresponds to the dynamic class of the receiver object.

    Definition Classes
      AnyRef → Any
    Note

      not specified by SLS as a member of AnyRef

17. #### def hashCode(): Int

    The hashCode method for reference types.

    The hashCode method for reference types. See hashCode in scala.Any.

    returns

      the hash code value for this object.

    Definition Classes
      AnyRef → Any

18. #### final def isInstanceOf[T0]: Boolean

    Test whether the dynamic type of the receiver object is `T0`.

    Test whether the dynamic type of the receiver object is `T0`.

    Note that the result of the test is modulo Scala's erasure semantics. Therefore the expression `1.isInstanceOf[String]` will return `false`, while the expression `List(1).isInstanceOf[List[String]]` will return `true`. In the latter example, because the type argument is erased as part of compilation it is not possible to check whether the contents of the list are of the specified type.

    returns

      `true` if the receiver object is an instance of erasure of type `T0`; `false` otherwise.

    Definition Classes
      Any

19. #### final def ne(arg0: AnyRef): Boolean

    Equivalent to `!(this eq that)`.

    Equivalent to `!(this eq that)`.

    returns

      `true` if the argument is not a reference to the receiver object; `false` otherwise.

    Definition Classes
      AnyRef

20. #### final def notify(): Unit

    Wakes up a single thread that is waiting on the receiver object's monitor.

    Wakes up a single thread that is waiting on the receiver object's monitor.

    Definition Classes
      AnyRef
    Note

      not specified by SLS as a member of AnyRef

21. #### final def notifyAll(): Unit

    Wakes up all threads that are waiting on the receiver object's monitor.

    Wakes up all threads that are waiting on the receiver object's monitor.

    Definition Classes
      AnyRef
    Note

      not specified by SLS as a member of AnyRef

22. #### final def synchronized[T0](arg0: ⇒ T0): T0

    Definition Classes
      AnyRef

23. #### def toString(): String

    Creates a String representation of this object.

    Creates a String representation of this object. The default representation is platform dependent. On the java platform it is the concatenation of the class name, "@", and the object's hashcode in hexadecimal.

    returns

      a String representation of the object.

    Definition Classes
      AnyRef → Any

24. #### final def wait(): Unit

    Definition Classes
      AnyRef
    Annotations
      @throws( ... )

25. #### final def wait(arg0: Long, arg1: Int): Unit

    Definition Classes
      AnyRef
    Annotations
      @throws( ... )

26. #### final def wait(arg0: Long): Unit

    Definition Classes
      AnyRef
    Annotations
      @throws( ... )

27. #### def →[B](y: B): (Enclosures, B)

    Implicit information
      This member is added by an implicit conversion from Enclosures to ArrowAssoc[Enclosures] performed by method ArrowAssoc in scala.Predef.
    Definition Classes
      ArrowAssoc

### Inherited from AnyRef

### Inherited from Any

### Inherited by implicit conversion any2stringadd from Enclosures to any2stringadd[Enclosures]

### Inherited by implicit conversion StringFormat from Enclosures to StringFormat[Enclosures]

### Inherited by implicit conversion Ensuring from Enclosures to Ensuring[Enclosures]

### Inherited by implicit conversion ArrowAssoc from Enclosures to ArrowAssoc[Enclosures]

### Ungrouped